;============================================================
;GENERAL MACROS
;============================================================

;This macro will toggle the specified variable as well as its
;ATXconfig.ini counterpart, followed by a call to its assigned
;checkbox to set its state (checked, unchecked).
MACRO DOHOTSPOTCLICK var1,section1,key1,object1 {
	     mov eax,[var1]
	     and eax,1
	     xor eax,1
	     mov [var1],eax
	     add al,30h
	     lea edx,[esp-4]
	     push eax
      invoke WritePrivateProfileString,section1,key1,edx,ATXconfiginiFN
	     mov ecx,[object1]
	     add esp,4
	     mov eax,[ecx]
	     push [var1]	     ;1 for checked, 0 for unchecked
	     call DWORD [eax+58h]    ;call set checkbox state method
      jmp EXIT_HOTSPOT_METHOD_INTERCEPT
      }

      ;edi = base of keyboard command table (in EXE), esi = current tick count
MACRO ATXDRV_TESTKEY keyoffset,proc1,lasttickcount,interval {
local nofunccall
      mov eax,esi
      sub eax,lasttickcount
      cmp eax,interval
      push eax
	  jb nofunccall
      mov lasttickcount,esi
      invoke GetAsyncKeyState,[edi+keyoffset]
      test eax,80000000h
	   jz nofunccall
	   call proc1				;PROC MUST NOT POP PARAMETERS
	   or [ATXDRV_CURRENT.UseROTonSMVTOnly],2
      nofunccall:
      add esp,4
      }


MACRO SHOWTEMPMESSAGE themessage {
      mov [TempMessageString],themessage
      invoke GetTickCount
      mov [TempMessageTime],eax
      }

MACRO BBMCALL func1,varcheck1 {
local nofunccall
      cmp varcheck1,0
	  jz nofunccall
      call func1
      nofunccall:
      }

MACRO RCALL releaseproc, param1 {
local handlenull
      cmp param1,0
	  jz handlenull
      invoke releaseproc,param1
      mov param1,0
      handlenull:
      }

MACRO COMPSTR string1,string2 {
      lea ecx,string1
      lea edx,string2
      call CompareStrings
      }

MACRO NOZERO reg1 {
local notzero
      test reg1,reg1
	   jnz notzero
	   or reg1,1
      notzero:
      }

;esi must be set up properly for this macro; eax is destroyed

MACRO GETPLAYERLOCADDR	{ ;returns pointer to three loc values in eax
      mov eax,[LocationADDR]
      mov eax,[eax]
      mov eax,[eax+14h]       ;main player location/other object
      add eax,30h	      ;eax now points to 32-bit floats x,y,z positions
      } 		      ;directly in the executable

MACRO CLOSEHANDLE _handle {
local nohandle
      cmp _handle,0
	  jz nohandle
      invoke CloseHandle,_handle
      nohandle:
      }

MACRO FINDSTRINGSTART reg1 {	       ;scans for string start amidst space/tab characters
local EndSearchString,SearchLoop
      dec reg1
      SearchLoop:
      inc reg1
      cmp BYTE [reg1],09h	       ;tab
	  jz SearchLoop
      cmp BYTE [reg1],20h	       ;space
	  jz SearchLoop
      EndSearchString:
      }

MACRO FINDSTRINGEND reg1 {
local NoNullTerminator,StringSizeNull
      cmp BYTE [reg1],0
	  jz StringSizeNull
      NoNullTerminator:
      inc reg1
      cmp BYTE [reg1],0
	  jnz NoNullTerminator
      StringSizeNull:
      }


;note: In many instances, the line "and buffer1,0" is unnecessary, but will never
;cause problems. As such, it is not fully optimized.
MACRO LOCALRELEASE buffer1 {
      local NoRelease
	    cmp buffer1,0
	    jz NoRelease
	       invoke LocalFree,buffer1
	       mov buffer1,0
	    NoRelease:
	}

MACRO LOCALRELEASENONULL buffer1 {
      local NoRelease
	    cmp buffer1,0
	    jz NoRelease
	       invoke LocalFree,buffer1
	    NoRelease:
	}

MACRO VIRTUALRELEASE buffer1,size1  {
      local NoRelease
	    cmp buffer1,0
	    jz NoRelease
	       invoke VirtualFree,buffer1,size1,MEM_DECOMMIT
	       invoke VirtualFree,buffer1,0,MEM_RELEASE
	       mov buffer1,0
	    NoRelease:
	}
;=========================================================
;INITIALIZATION MACROS
;=========================================================

	WRITELOG_EXIT		equ	1
	WRITELOG_FORCEEXIT	equ	2

MACRO WRITELOG _string,_failbool,_doexit {
	or [DLLLoadSuccessBool],_failbool
	push _string
	push _failbool
	call WriteLogFile

   if _doexit eq WRITELOG_EXIT
	cmp _failbool,1
	    jz ExitInit
   end if
   if _doexit eq WRITELOG_FORCEEXIT
	    jmp ExitInit
   end if
	}

;===================================================================
;RT MACROS
;===================================================================
;some macros may only be valid for specific include files

MACRO CHAR_TOLOWERCASE reg {
      local label1
	cmp reg,5Ah
	ja label1
	cmp reg,41h
	jb label1
	add reg,20h
      label1:
	}

macro SCANFOR string1 {
      local ScanForLoop
	ScanForLoop:
	inc edi
	cmp edi,ebx
	jnb NEW_BITMAP_LOAD_FAIL
	cmp DWORD [edi],string1
	jnz ScanForLoop
	add edi,4
	cmp edi,ebx
	jnb NEW_BITMAP_LOAD_FAIL
	    }

;============================================================
;AT INIT MACROS
;============================================================
;registers eax,edi,ebp must be set properly for these macros

MACRO ALLOCAT _size {	;memory allocation
      push _size
      call [YAPAXI]	      ;allocates memory for instance
      add esp,4
      test eax,eax
	   jz UnableToAllocateMem
      mov edi,eax	      ;store pointer in edi
      }
;============================================================
MACRO GETVALUE EntryValue,_number {	;T-Script entry fetch
      push _number	      ;edi and ebp must be set up properly
      push DWORD [ebp-36]     ;passed value of edi
      push DWORD [ebp-32]     ;passed value of esi
      mov eax,[ebp-28]	      ;passed value of ebx
      add eax,EntryValue      ;table displacement for the T-Script value
      push eax
      call [GetEntryValueProc]
      add esp,16
      }
;============================================================
;retrieves and stores value from returned object
;_member is the member in the destination object

MACRO SETVALUE ValueType,_member {
	local WrongValueType
	local NoObject
test eax,eax
     jz NoObject
cmp DWORD [eax+4],ValueType
     jnz WrongValueType
	if ValueType=value_string
	mov eax,[eax+40h]
	else
	mov eax,[eax+28h]	;if string, this is only string length
	end if			;if other value, this is direct value
mov [edi+((_member-1)*4)],eax
jmp NoObject
WrongValueType:
xor eax,eax
NoObject:
}				;eax has value if needed
;============================================================
MACRO SETVALUE2 ValueType {	;same as above, but only returns pointer in eax
	local WrongValueType
	local NoObject
test eax,eax
     jz NoObject
cmp DWORD [eax+4],ValueType
     jnz WrongValueType
	if ValueType=value_string
	mov eax,[eax+40h]
	else
	mov eax,[eax+28h]	;if string, this is only string length
	end if			;if other value, this is direct value
jmp NoObject
WrongValueType:
xor eax,eax
NoObject:
}
;============================================================
MACRO MOVESTRING dest,source,length {
      mov ecx,length
      push esi
      push edi
      mov esi,source
      lea edi,dest
      rep movsb 	   ;move string to allocated memory
      pop edi
      pop esi
      }
;============================================================

