;=====================================================
;COUNTER FUNCTIONS
;=====================================================
SetNewTimeStamp:
	cmp [CounterFirstRun],1
	jz FirstRunOnly_Timestamp
	cmp [USE_COUNTER],1
	jz SHOW_COUNTER
	ret

FirstRunOnly_Timestamp:

	mov [CounterFirstRun],0
	invoke GetTickCount
	mov [FirstTimeStamp],eax

	cmp [USE_COUNTER],1
	    jz SHOW_COUNTER
	ret

;===================================================
;[ebp-4]=hours
;[ebp-8]=minutes
;[ebp-12]=seconds
;ADDR [ebp-100]=buffer for time stamp string (result)

SHOW_COUNTER:
push ebp
mov ebp,esp
sub esp,12

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	invoke GetTickCount
	sub eax,[FirstTimeStamp]
	mov ebx,eax

	cdq
	mov ecx,(60*60*1000)	;milliseconds/hour
	div ecx 		;get # hours passed
	mov [ebp-4],eax

	mov eax,edx		;remainder=milliseconds left
	cdq
	mov ecx,(60*1000)	;milliseconds/minute
	div ecx
	mov [ebp-8],eax

	mov eax,edx		;remainder=milliseconds left
	cdq
	mov ecx,(1000)		;milliseconds/second
	div ecx
	mov [ebp-12],eax

	mov ebx,stack_ext_buffer
invoke wsprintf,ebx,Time_Format_String,[ebp-4],[ebp-8],[ebp-12]
	add esp,20
invoke TextOut,edi,0,TIME_STAMP_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop ebp
ret


;============================================================
;displays FPS (.5 second interval)
;============================================================
DisplayFPS:
       mov eax,[BaseDDSurfaceADDR]
       mov ecx,[eax]
       call [EXEPROC_GETDDSURFDC]      ;GetDC for DDraw surface via EXE
       mov edi,eax

invoke GetTickCount
       mov ecx,eax
       sub eax,[FPS_lastframetime]
       cmp eax,500
	   jb NoChangeFPSvalue

       push eax
       mov [FPS_lastframetime],ecx
       fild [FPS_framecount]
       fild DWORD [esp]
       fdivp st1,st0
       and [FPS_framecount],0
       fmul [float_1000]
       add esp,4
       fstp QWORD [FPS_lastfps]
       NoChangeFPSvalue:

       inc [FPS_framecount]

       mov ebx,stack_ext_buffer
invoke sprintf,ebx,FPS_string,DWORD [FPS_lastfps],DWORD [FPS_lastfps+4]
       add esp,16

invoke TextOut,edi,0,FPS_MSG,ebx,eax

       mov eax,[BaseDDSurfaceADDR]
       push edi 		;DDraw ReleaseDC
       mov ecx,[eax]
       call [EXEPROC_RELEASEDDSURFDC]

ret

;============================================================
;displays current draw distance
;============================================================
DisplayDrawDistance:

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	mov ebx,stack_ext_buffer
	sub esp,8
	mov edx,[DrawDistanceVarADDR]
	fld DWORD [edx]
	fstp QWORD [esp]

invoke sprintf,ebx,DrawDistDisplayString
	add esp,16

invoke TextOut,edi,0,SHOW_DRAW_DIST_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

invoke GetTickCount
       sub eax,[DrawDistDisplayTime]
       cmp eax,3000
	   jb NoChangeDrawDistDisplayTime
       and [DrawDistDisplayTime],0
       NoChangeDrawDistDisplayTime:

ret

;============================================================
;displays Player HitPoints and MaxHitPoints values
;============================================================
DisplayPlayerHealth:

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax
	mov ebx,stack_ext_buffer

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov ecx,[eax]

;Player MaxHitPoints
	sub esp,8
	fld DWORD [ecx+54h]
	fstp QWORD [esp]
;Player HitPoints
	sub esp,8
	fld DWORD [ecx+50h]
	fstp QWORD [esp]

invoke sprintf,ebx,ShowPlayerHealth_STRING
	add esp,24

invoke TextOut,edi,0,PLAYERHEALTH_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

ret

;============================================================
;shows new keys active or not
;============================================================
DisplayNewKeysState:
cmp [ToggleKeysShowStateTime],0
    jnz DoDisplayNewKeysState
    ret
DoDisplayNewKeysState:

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edx,stack_ext_buffer
	mov edi,eax

	mov [edx], DWORD "NEW "
	mov [edx+4],DWORD "KEYS"
	mov [edx+8],DWORD ": ON"
	mov [edx+12],DWORD 00000020h

	cmp [ToggleNewKeys_BOOL],1
	    jz NewKeysAreOn_32433
	mov [edx+9],DWORD " OFF"
	NewKeysAreOn_32433:

invoke TextOut,edi,0,KEY_STATE_MSG,edx,13

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

invoke GetTickCount
       sub eax,[ToggleKeysShowStateTime]
       cmp eax,3000
	   jb NoChangeToggleKeysTime
       and [ToggleKeysShowStateTime],0
       NoChangeToggleKeysTime:

ret


;============================================================
;displays current game speed
;============================================================
DisplayGameSpeed:

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax
	mov ebx,stack_ext_buffer

	sub esp,8
	mov edx,[GameSpeedVarADDR]
	fld DWORD [edx]
	fstp QWORD [esp]

invoke sprintf,ebx,GameSpeedDisplayString
	add esp,16

invoke TextOut,edi,0,SHOW_DRAW_DIST_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

ret