;============================================================
;ActBite code intercept         ;ecx = ActBite object
;============================================================
;IMPORTANT NOTE!!!!!!
;This code is also called upon the "Feint" AI behavior; differentiation
;between the two acts must be done by verifying the object passed in ecx (VTable or signature)

On_ActBite_Main_Code:		;eax and edx may be destroyed

cmp DWORD [ecx+4Ch],'Bite'	;differentiate between ActBite and ActFeint via class signature
    jnz Exit_On_ActBite

cmp [UseDisableActJumpNew],0
    jnz NoActJumpNew_44543
	call ACTJUMPNEW_MAIN
NoActJumpNew_44543:

;============================================================
cmp [UseMXTBITE],0
    jnz do_mxt_bite_main

Exit_On_ActBite:
	pop eax 	;get return address
	sub esp,138h	;replaced code
	jmp eax 	;back to normal biting code

;============================================================
;MatrixTres slowdown        ;radius=sqrt(Xdiff^2 + Ydiff^2 + Zdiff^2)
;============================================================
do_mxt_bite_main:
	push ecx
	push esi
	push ebx

	mov edx,[CAnimalBuffer]
	test edx,edx
	mov ebx,[CAnimalBufferEnd]
	     jz NoMXTOnBiteSimCall

	FindDinoForActBiteInstanceLoop:
	mov esi,[edx]
	mov eax,[esi+0DCh]		;instance's main AI sub-class
	cmp ecx,[eax+18h]		;instance's ActBite sub-class
	    jz END_FindDinoForActBiteInstanceLoop
	add edx,sizeof.canimal_info
	cmp edx,ebx
	    jb FindDinoForActBiteInstanceLoop
	    jmp NoMXTOnBiteSimCall
	END_FindDinoForActBiteInstanceLoop:

	;esi = dino instance
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;player object

	fld DWORD [esi+30h]	;dino's X position
	fsub DWORD [edx+30h]	;player's X pos
	fmul st0,st0		;Xdiff^2

	fld DWORD [esi+34h]	;dino's Y position
	fsub DWORD [edx+34h]	;player's Y pos
	fmul st0,st0		;Ydiff^2

	fld DWORD [esi+38h]	;dino's Z position
	fsub DWORD [edx+38h]	;player's Z pos
	fmul st0,st0		;Zdiff^2
	fadd st0,st1		;Zdiff^2+Ydiff^2
	fadd st0,st2		;Zdiff^2+Ydiff^2+Xdiff^2

	fcomp [MXTRadiusEXP2]
	fstsw ax
	fstp st0
	fstp st0

	test ax,0100010100000000b
	     jz NoMXTOnBiteSimCall

	mov ecx,AT100SimulatedObject
	call AT100MAIN

NoMXTOnBiteSimCall:
	pop ebx
	pop esi
	pop ecx

	pop eax
	sub esp,138h
	jmp eax

;============================================================
MXTInGameIntervalHandler:
;============================================================

	call MXTGetCurrentTransitionState
	cmp eax,1
	    jz MXTIntrHandlerEnterTransition

	cmp eax,2
	    jz MXTIntrHandlerFixedSlowSpeed

	cmp eax,3
	    jz MXTIntrHandlerExitTransition

	mov edx,[GameSpeedVarADDR]
	mov eax,[NormalGameSpeed]
	mov [edx],eax		;back to fast speed
ret

;------------------------
MXTIntrHandlerEnterTransition:
;------------------------
	mov ecx,[MXTEnterTransitionInterval]
	test ecx,ecx
	     jz MXTIntrHandlerEnterTransition_EXIT
;MXTSlowSpeedCurrent
	mov DWORD [esp-4],edx
	mov DWORD [esp-8],ecx
	fild DWORD [esp-4]
	fild DWORD [esp-8]
	fdivp st1,st0		   ;currenttimeleft/interval  (diminishes with tick++)
	mov edx,[GameSpeedVarADDR]
	fmul [MXTSpeedVariationCurrent]
	fadd [MXTSlowSpeedCurrent]
	fstp DWORD [edx]
MXTIntrHandlerEnterTransition_EXIT:
ret

;------------------------
MXTIntrHandlerFixedSlowSpeed:
;------------------------
	mov edx,[GameSpeedVarADDR]
	mov eax,[MXTSlowSpeedCurrent]
	mov [edx],eax		    ;set game speed to 'slow' mode
ret

;------------------------
MXTIntrHandlerExitTransition:
;------------------------
	mov ecx,[MXTExitTransitionInterval]
	test ecx,ecx
	     jz MXTIntrHandlerExitTransition_EXIT
;MXTSlowSpeedCurrent
	mov DWORD [esp-4],edx
	mov DWORD [esp-8],ecx
	fild DWORD [esp-4]
	fild DWORD [esp-8]
	fdivp st1,st0		   ;currenttimeleft/interval  (diminishes with tick++)
	mov edx,[GameSpeedVarADDR]
	fmul [MXTSpeedVariationCurrent]
	fsubr [NormalGameSpeed]
	fstp DWORD [edx]
MXTIntrHandlerExitTransition_EXIT:
ret


;============================================================
MXTGetCurrentTransitionState:	    ;returns in eax - will disabled effect if expired
;============================================================
;0 - MXT disabled
;1 - Enter transition
;2 - in-effect
;3 - Exit transition
;FOR 1,2 and 3, value returned in edx is tick count left between current tick
;and next limit tick (time limit of current transition)

cmp [MXTStateEnabled],0
    jz MXTTransStateDisabled

	invoke GetTickCount
	mov edx,[MXTLastTick]
	add edx,[MXTEnterTransitionInterval]
	cmp eax,edx
	    jb MXTTransStateEnterTransition

	add edx,[MXTStateInterval]
	cmp eax,edx
	    jb MXTTransStateInEffect

	add edx,[MXTExitTransitionInterval]
	cmp eax,edx
	    jb MXTTransStateExitTransition

	mov [MXTStateEnabled],0
MXTTransStateDisabled:
	xor eax,eax
ret

MXTTransStateEnterTransition:
	sub edx,eax
	mov eax,1
ret

MXTTransStateInEffect:
	sub edx,eax
	mov eax,2
ret

MXTTransStateExitTransition:
	sub edx,eax
	mov eax,3
ret
