;=====================================================
;create map index save file for savegame
;=====================================================


;[DWORD [CPARTICLESBUFADDRVAR] - 16] = pointer to list of
;particle name objects (size = 6 DWORDS) - Type ID is member +16
;[DWORD [CPARTICLESBUFADDRVAR] + 4] = number of CParticle objects

;SAVEDMAP.xxx format (starting at offset 0):
;
;16 bytes       - 2D Map X-Y position values (4 32-bit floats)
;80 bytes       - 2D Map BMP name (*.bmp+null-terminator)
;4 bytes        - Game speed value (32-bit float)
;4 bytes        - Number of bytes in "current hint" string (0 if none)
;variable       - "current hint" string

SAVE_SAVED_MAP_STATE:	;ebx = file handle

mov edx,[esp+1E4h]	;REPLACED CODE (7 bytes)
			;edx = pointer to SAVEGAME.xxx filename + path
push ebx
push ecx
push esi
push edi
xor ebx,ebx

	mov esi,edx
	mov edi,SAVEGAMENAME_BUFFER
	call TransferString
;=====================================================

cmp DWORD [edi-4],'.scx'
    jz NO_SAVEMAP_SAVE_A
cmp DWORD [edi-4],'.SCX'
    jz NO_SAVEMAP_SAVE_A

mov DWORD [edi-8],'DMAP'	;'SAVEGAME' replaced by 'SAVEDMAP'

invoke DeleteFile,SAVEGAMENAME_BUFFER	;delete "SAVEDMAP.xxx" if existing

cmp [currentbitmap],0			;if no map, make sure to write only null characters
    jnz NO_MAP_SAVE_NULLIFY_1
	push edi
	xor eax,eax
	mov edi,CURRENT_MAP_VALUES
	mov ecx,4
	rep stosd
	mov edi,CURRENT_MAP_BUFFER
	mov ecx,20
	rep stosd
	pop edi
NO_MAP_SAVE_NULLIFY_1:

invoke CreateFile,SAVEGAMENAME_BUFFER,GENERIC_WRITE,0,0,\
		CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	test eax,eax
	     jz SAVED_FILE_LOAD_FAIL2
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL2
	mov ebx,eax

invoke SetFilePointer,eax,0,0,FILE_BEGIN
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE MAP POSITION VALUES
;------------------------------------------
	sub esp,4
	mov eax,esp		;write POSITION values
invoke WriteFile,ebx,CURRENT_MAP_VALUES,16,eax,0
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,16
	    jnz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE 2D MAP NAME
;------------------------------------------
	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,CURRENT_MAP_BUFFER,80,eax,0    ;write BITMAP NAME
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,80
	    jnz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE CURRENT GAME SPEED
;------------------------------------------
	mov eax,[NormalGameSpeed]
	mov DWORD [stack_ext_buffer],eax

	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,4,eax,0	 ;write GAME SPEED
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,4
	    jnz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE CURRENT HINT (IF AT106-TYPE)
;------------------------------------------
mov edx,[CURRENT_HINT_ID_ADDR]
mov eax,[HINT_NEW_STRING_ADDR]
cmp DWORD [edx],NEW_HINT_TYPE_ID
    jnz NoSaveCurrentHint_SAVEGAME
test eax,eax
     jz NoSaveCurrentHint_SAVEGAME

	mov edi,eax
	FINDSTRINGEND edi
	sub edi,eax
	inc edi

	sub esp,4
	mov DWORD [stack_ext_buffer],edi
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,4,eax,0	 ;write HINT string length
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,4
	    jnz SAVED_FILE_LOAD_FAIL2

	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,[HINT_NEW_STRING_ADDR],edi,eax,0	 ;write HINT string
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,edi
	    jnz SAVED_FILE_LOAD_FAIL2

jmp SaveCurrentHint_SAVEGAME_OK

NoSaveCurrentHint_SAVEGAME:
	sub esp,4
	mov DWORD [stack_ext_buffer],0
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,4,eax,0	 ;write HINT string length as NULL
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,4
	    jnz SAVED_FILE_LOAD_FAIL2

SaveCurrentHint_SAVEGAME_OK:

;------------------------------------------
SAVED_FILE_LOAD_FAIL2:
;------------------------------------------
	CLOSEHANDLE ebx

NO_SAVEMAP_SAVE_A:

pop edi
pop esi
pop ecx
pop ebx

mov edx,[esp+1E4h]	;restore edx
ret