;============================================================
SetRandomDinoStartPositions:
;============================================================
;Works with CAnimal instances only, not included in output; kept for reference

;[ebp-12] = number of ENTRY sections
;[ebp-8] = bool buffer
;[ebp-4] = number of ENTRY sections (variable)

;The following macro is no longer used to set the 6 position values
;(the standard teleport method is used instead).
;MACRO WRITEPOS disp1 {          ;writes 5 last position values
;       mov [esi+110h+disp1],eax
;       mov [esi+170h+disp1],eax
;       mov [esi+1D0h+disp1],eax
;       mov [esi+230h+disp1],eax
;       mov [esi+290h+disp1],eax
;       }


cmp [UseRandomDinoLocations],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_BUF],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_BUF_SIZE],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_Names_INDEX],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_Names_BUF],0
    jz NoSetRandomDinoStartPositions
cmp [CAnimal_Names_BUF_SIZE],0
    jz NoSetRandomDinoStartPositions

push ebp
mov ebp,esp
sub esp,12

	mov edi,MapsDirBuffer
	add edi,[MapsPathSize]
	mov esi,[LEVELNAME_OBJ] 	 ;SCN level name
	mov DWORD [edi],'RAN\'		 ;'RAN\' folder
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.ini'	;modify extension

;get number of ENTRY sections
invoke GetPrivateProfileInt,MAIN_SECTION,ENTRY_COUNT,1500000,MapsDirBuffer
	cmp eax,1500000
	    jz FileNotFound_RAND
	mov [ebp-12],eax
	mov [ebp-4],eax

	test eax,eax
	     jz NoAllocENTRYBuffer
	invoke LocalAlloc,LPTR,eax	;boolean buffer for ENTRYs
	       test eax,eax
		    jz FileNotFound_RAND
	NoAllocENTRYBuffer:
	mov [ebp-8],eax

	call RANDOMIZE_RANDOM_PROC
	xor ebx,ebx
	call MainDinoRandomizeProc

	LOCALRELEASE DWORD [ebp-8]

FileNotFound_RAND:
mov esp,ebp
mov ecx,[MapsPathSize]
pop ebp
mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
NoSetRandomDinoStartPositions:
ret

;============================================================
MainDinoRandomizeProc:	;ebx=Instance specifier/count
			;RAND_INST_NAME_BUF = "Instance#" string INI value (instance name)
			;RAND_RSRV_ENTRY_BUF = "Reserved#" string INI value
			;                     (may be replaced by "ENTRY#" string later)
;============================================================
add ebx,1

invoke wsprintf,RAND_BUF1,INSTANCE_STRING,ebx
	add esp,12

;get associated instance's name
invoke GetPrivateProfileString,MAIN_SECTION,RAND_BUF1,NULL_STRING,\
		RAND_INST_NAME_BUF,50,MapsDirBuffer
	cmp DWORD [RAND_INST_NAME_BUF],'NULL'
	    jz EndMainDinoRandomizeProc

invoke wsprintf,RAND_BUF1,RESERVE_STRING,ebx
	add esp,12

;get "reserved" section for instance
invoke GetPrivateProfileString,MAIN_SECTION,RAND_BUF1,NULL_STRING,\
		RAND_RSRV_ENTRY_BUF,50,MapsDirBuffer
	cmp DWORD [RAND_RSRV_ENTRY_BUF],'NULL'
	    jnz UseSpecificSection_RAND

	call GetRandomEntry_RAND
	     test eax,eax
		  jz MainDinoRandomizeProc   ;no more available ENTRY sections?
					     ;(does not quit procedure in case non-random entries present after)
;print random ENTRY section to RAND_RSRV_ENTRY_BUF (instead of reserved, defined instance)
invoke wsprintf,RAND_RSRV_ENTRY_BUF,ENTRY_STRING,eax
	add esp,12

UseSpecificSection_RAND:
	call SetRandomLocationFinal
jmp MainDinoRandomizeProc

EndMainDinoRandomizeProc:
ret

;============================================================
GetRandomEntry_RAND:	 ;returns random entry below or equal to [ebp-12]
;============================================================
cmp DWORD [ebp-4],0
    jz NoGetRandomEntry_RAND

     push DWORD [ebp-12]
call GetRandomNumber		    ;pick an ENTRY section randomly
     mov ecx,[ebp-8]		    ;(ENTRY boolean buffer)
     cmp BYTE [eax+ecx-1],0	    ;has it already been picked?
	 jz GetRandomNumberSuccess

WaitForFreeENTRY_RAND:
     cmp eax,[ebp-12]		    ;find next unpicked ENTRY section (sequentially
	 jb NotEndOfList_RAND
     xor eax,eax
     NotEndOfList_RAND:
     inc eax
     cmp BYTE [eax+ecx-1],0
	 jnz WaitForFreeENTRY_RAND  ;despite appearances, this will never make an endless loop, because
				    ;of [ebp-4] which is tested earlier (if it is not zero,
				    ;there is automatically at least one free ENTRY section left)
GetRandomNumberSuccess:
	or BYTE [eax+ecx-1],1
	dec DWORD [ebp-4]
ret

NoGetRandomEntry_RAND:
	xor eax,eax
ret		     ;returns eax=0 if no more available ENTRYs

;============================================================
SetRandomLocationFinal: ;section specified at RAND_RSRV_ENTRY_BUF
;============================================================
			;RAND_LOC_STR_BUF = "Location#" string INI value
invoke GetPrivateProfileInt,RAND_RSRV_ENTRY_BUF,ENTRIES_STRING,0,MapsDirBuffer
       test eax,eax
	   jz NoSetRandomLocationFinal

       push eax
       call GetRandomNumber

;get Location# string
invoke wsprintf,RAND_LOC_STR_BUF,LOCATION_STRING,eax
       add esp,12

       ;RAND_BUF1 -> replaces previous 'Reserve#' string (not value of)
invoke GetPrivateProfileString,RAND_RSRV_ENTRY_BUF,RAND_LOC_STR_BUF,NULL_STRING,RAND_BUF1,\
		50,MapsDirBuffer	;get location float values

       cmp DWORD [RAND_BUF1],'NULL'
	   jz NoSetRandomLocationFinal

       call GetCurrentInstanceObject
       test eax,eax
	    jz NoSetRandomLocationFinal

;SET NEW LOCATION
       mov esi,eax
;NO LONGER USED /*
;add eax,30h
;*/
       mov eax,Temp_Fly_Buffer
       mov edi,RAND_BUF1
       lea ecx,[eax+4]
       lea edx,[eax+8]

;write first positions values
invoke sscanf,edi,FLOAT_RETRIEVE_STRING,eax,ecx,edx
       add esp,20

       push edi
       push esi
       lea edi,[Temp_Fly_Buffer+0Ch]
       add esi,3Ch
       mov ecx,5
       rep movsd
       pop esi
       pop edi

       mov ecx,esi
       push 0
       mov eax,[ecx]
       push Temp_Fly_Buffer
       call DWORD [eax+38h]	 ;Teleport dino

;NO LONGER USED /*
;       mov eax,[esi+30h]        ;write the 5 other position variables
;       WRITEPOS 0
;       mov eax,[esi+34h]
;       WRITEPOS 4
;       mov eax,[esi+38h]
;       WRITEPOS 8
;*/

;============================================================
;SET OTHER VARIABLES FROM INI LIST FILE

invoke GetPrivateProfileFloat,RAND_RSRV_ENTRY_BUF,STAYNEARMAX_STRING,ZERO_STRING,MapsDirBuffer
       test eax,eax
	    jz NoSetStayNearMaxForcedValue
       mov edx,[esi+0DCh]
       mov edx,[edx+68h]    ;get ActStayNear instance
       mov [edx+64h],eax    ;set new StayNearMax value
NoSetStayNearMaxForcedValue:

invoke GetPrivateProfileFloat,RAND_RSRV_ENTRY_BUF,STAYNEAROK_STRING,ZERO_STRING,MapsDirBuffer
       test eax,eax
	    jz NoSetStayNearOKForcedValue
       mov edx,[esi+0DCh]
       mov edx,[edx+68h]     ;get ActStayNear instance
       mov [edx+68h],eax     ;set new StayNearOK value
NoSetStayNearOKForcedValue:  ;2A68=staynearmax, 2A70=staynearok

invoke GetPrivateProfileFloat,RAND_RSRV_ENTRY_BUF,WAKEUP_STRING,ZERO_STRING,MapsDirBuffer
       test eax,eax
	    jz NoSetWakeUpForcedValue
       mov edx,[esi+0DCh]
       mov [edx+340h],eax    ;set new WakeUp value
NoSetWakeUpForcedValue:

invoke GetPrivateProfileFloat,RAND_RSRV_ENTRY_BUF,SLEEP_STRING,ZERO_STRING,MapsDirBuffer
       test eax,eax
	    jz NoSetSleepForcedValue
       mov edx,[esi+0DCh]
       mov [edx+344h],eax    ;set new Sleep value
NoSetSleepForcedValue:

invoke GetPrivateProfileInt,RAND_RSRV_ENTRY_BUF,NOGETOUT_STRING,0,MapsDirBuffer
       test eax,eax
	    jz NoDisableActGetOut
       mov edx,[esi+0DCh]
       mov eax,[edx+7Ch]
       and BYTE [eax+34h],0FBh		;ActGetOut enable/disable bool
NoDisableActGetOut:

NoSetRandomLocationFinal:
ret

;============================================================
GetCurrentInstanceObject:	;returns in eax, uses RAND_INST_NAME_BUF for instance name
;============================================================
xor edi,edi
GetCurrentInstanceObject_LOOP:

mov eax,[CAnimal_Names_INDEX]
mov edx,[eax+edi]
mov esi,RAND_INST_NAME_BUF	;esi=instance name from INI
add edx,[CAnimal_Names_BUF]	;edx=instance name from EXE (current)

	StringScanLoop_RAND:
	mov al,[esi]
	mov cl,[edx]
	    cmp al,cl
		jnz END_StringScanLoop_RAND
	    test al,al
		 jz Instance_Found_RAND
	inc esi
	inc edx
	jmp StringScanLoop_RAND

END_StringScanLoop_RAND:
add edi,4
cmp edi,[CAnimal_BUF_SIZE]
    jb GetCurrentInstanceObject_LOOP
xor eax,eax
ret

Instance_Found_RAND:
mov edx,[CAnimal_BUF]
mov eax,[edx+edi]
ret
